using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Drawing;

namespace Parkhaus
{
    class Auto
    {
        #region Variables
        private static Random rnd = new Random();
        public String name { get; set; }
        private Parkhaus parkhaus;
        public Color color { get; set; }
        private Queue<Auto> _changes = new Queue<Auto>();
        public bool _inParking = false;
        #endregion

        public Auto(String name, Color color, Parkhaus parkhaus, ref Queue<Auto> changes)
        {
            this.name = name;
            this.parkhaus = parkhaus;
            this.color = color;
            this._changes = changes;
        }

        public void Drive(object o)
        {
            while (true)
            {
                Thread.Sleep(rnd.Next(70000));
                this._inParking = true;
                WriteStatus(this);
                parkhaus.Passieren(this);
                Thread.Sleep(rnd.Next(10000));
                parkhaus.Verlassen(this);
                this._inParking = false;
                WriteStatus( this);
            }
        }

        private void WriteStatus(Auto car)
        {
            if (_changes.Count == 10) // Maximal 10 Eintrge anzeigen lassen
            {
                _changes.Dequeue();
            }
            _changes.Enqueue(car);
        }
    }
}
